Index: /trunk/kernel/devices/dev_dma.c
===================================================================
--- /trunk/kernel/devices/dev_dma.c	(revision 656)
+++ /trunk/kernel/devices/dev_dma.c	(revision 657)
@@ -2,5 +2,5 @@
  * dev_dma.c - DMA (Interrupt Controler Unit) generic device API implementation.
  *
- * Authors   Alain Greiner  (2016,2017,2018,2019)
+ * Authors   Alain Greiner  (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -84,11 +84,11 @@
 
 ////////////////////////////////////////////////
-error_t dev_dma_remote_memcpy( xptr_t    dst_xp,
-                               xptr_t    src_xp,
-                               uint32_t  size )
+error_t dev_dma_async_memcpy( xptr_t    dst_xp,
+                              xptr_t    src_xp,
+                              uint32_t  size )
 {
     thread_t * this = CURRENT_THREAD;
 
-#if CONGIG_DEBUG_DEV_DMA
+#if DEBUG_DEV_DMA
 uint32_t cycle = (uint32_t)hal_get_cycles();
 if( CONGIG_DEBUG_DEV_DMA < cycle )
@@ -107,4 +107,5 @@
 
     // register command in calling thread descriptor
+    this->dma_cmd.sync    = false;
     this->dma_cmd.dev_xp  = dev_xp;
     this->dma_cmd.dst_xp  = dst_xp;
@@ -112,10 +113,10 @@
     this->dma_cmd.size    = size;
 
-    // register client thread in waiting queue, activate server thread
-    // block client thread on THREAD_BLOCKED_IO and deschedule.
-    // it is re-activated by the ISR signaling IO operation completion.
+    // register the client thread in waiting queue, activate the server thread,
+    // block the client thread on THREAD_BLOCKED_IO, and deschedule.
+    // it is re-activated by the server thread  when the transfer is completed.
     chdev_register_command( dev_xp );
 
-#if CONGIG_DEBUG_DEV_DMA
+#if DEBUG_DEV_DMA
 cycle = (uint32_t)hal_get_cycles();
 if( CONGIG_DEBUG_DEV_DMA < cycle )
@@ -127,4 +128,54 @@
     return this->dma_cmd.error;  
 
-}  // dev_dma_remote_memcpy()
+}  // dev_dma_async_memcpy()
 
+//////////////////////////////////////////////
+error_t dev_dma_sync_memcpy( xptr_t    dst_xp,
+                             xptr_t    src_xp,
+                             uint32_t  size )
+{
+    thread_t * this = CURRENT_THREAD;
+
+#if DEBUG_DEV_DMA
+uint32_t cycle = (uint32_t)hal_get_cycles();
+if( CONGIG_DEBUG_DEV_DMA < cycle )
+printk("\n[DBG] %s : thread %x enters / dst %l / src %l / size = %x\n",
+__FUNCTION__ , this, dst_xp, src_xp, size );
+#endif
+
+    // select DMA channel corresponding to core lid
+    uint32_t channel = this->core->lid;
+
+    // get extended pointer on selected DMA chdev descriptor
+    xptr_t  dev_xp = chdev_dir.dma[channel];
+
+// check DMA chdev definition
+assert( (dev_xp != XPTR_NULL) , "undefined DMA chdev descriptor" );
+
+    // register command in calling thread descriptor
+    this->dma_cmd.sync    = true;
+    this->dma_cmd.dev_xp  = dev_xp;
+    this->dma_cmd.dst_xp  = dst_xp;
+    this->dma_cmd.src_xp  = src_xp;
+    this->dma_cmd.size    = size;
+
+    // get driver command function
+    cxy_t       dev_cxy = GET_CXY( dev_xp );
+    chdev_t   * dev_ptr = GET_PTR( dev_xp );
+    dev_cmd_t * cmd = (dev_cmd_t *)hal_remote_lpt( XPTR( dev_cxy , &dev_ptr->cmd ) );
+
+    // call directly the blocking driver function
+    cmd( XPTR( local_cxy , this ) );
+
+#if DEBUG_DEV_DMA
+cycle = (uint32_t)hal_get_cycles();
+if( CONGIG_DEBUG_DEV_DMA < cycle )
+printk("\n[DBG] %s : thread %x exit / dst %l / src %l / size = %x\n",
+__FUNCTION__ , this, dst_xp, src_xp, size );
+#endif
+
+    // return I/O operation status from calling thread descriptor
+    return this->dma_cmd.error;  
+
+}  // dev_dma_sync_memcpy()
+
Index: /trunk/kernel/devices/dev_dma.h
===================================================================
--- /trunk/kernel/devices/dev_dma.h	(revision 656)
+++ /trunk/kernel/devices/dev_dma.h	(revision 657)
@@ -2,5 +2,5 @@
  * dev_dma.h - DMA (Direct Memory Access) generic device API definition.
  *
- * Authors   Alain Greiner  (2016,2017,2018)
+ * Authors   Alain Greiner  (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -36,6 +36,9 @@
  * to/from remote clusters. The burst size is defined by the cache line size.
  * Each DMA channel is described by a specific chdev descriptor, handling its private
- * waiting threads queue. It implement one single command : move data from a (remote)
- * source buffer to a (remote) destination buffer.
+ * waiting threads queue. It implements two blocking commands :
+ * - move synchronously data from a remote source buffer to a remote destination buffer,
+ *   using a polling policy to wait completion (No DMA_IRQ use).
+ * - move synchronously data from a remote source buffer to a remote destination buffer,
+ *   using a descheduling policy to wait completion (reactivated bythe IDMA_IRQ).
  ****************************************************************************************/
  
@@ -50,5 +53,6 @@
 typedef struct dma_command_s
 {
-    xptr_t      dev_xp;    /*! extended pointer on the DMA chdev descriptor             */
+    bool_t      sync;      /*! polling policy if true / descheduling policy if false     */
+    xptr_t      dev_xp;    /*! extended pointer on the DMA chdev descriptor              */
     xptr_t      src_xp;    /*! extended pointer on source buffer.                        */
     xptr_t      dst_xp;    /*! extended pointer on destination buffer.                   */
@@ -83,14 +87,27 @@
 /*****************************************************************************************
  * This blocking function register a DMA request in the device queue.
- * It uses a descheduling policy to wait completion, and return an error status
- * when the transfer is completed.
+ * It uses a descheduling policy to wait completion, 
+ * It return an error status when the transfer is completed.
  *****************************************************************************************
- * @ dst        : extended pointer on destination buffer.
- * @ src        : extended pointer on Rsource buffer.
+ * @ dst_xp     : extended pointer on destination buffer.
+ * @ src_xp     : extended pointer on source buffer.
  * @ size       : number of bytes to move.
  ****************************************************************************************/
-error_t dev_dma_remote_memcpy( xptr_t     dst_xp,
-                               xptr_t     src_xp,
-                               uint32_t   size );    
+error_t dev_dma_async_memcpy( xptr_t     dst_xp,
+                              xptr_t     src_xp,
+                              uint32_t   size );    
+
+/*****************************************************************************************
+ * This blocking function register a DMA request in the device queue.
+ * It uses a polling policy to wait completion.
+ * It return an error status when the transfer is completed.
+ *****************************************************************************************
+ * @ dst_xp     : extended pointer on destination buffer.
+ * @ src_xp     : extended pointer on source buffer.
+ * @ size       : number of bytes to move.
+ ****************************************************************************************/
+error_t dev_dma_sync_memcpy( xptr_t     dst_xp,
+                             xptr_t     src_xp,
+                             uint32_t   size );    
 
 
Index: /trunk/kernel/devices/dev_fbf.c
===================================================================
--- /trunk/kernel/devices/dev_fbf.c	(revision 656)
+++ /trunk/kernel/devices/dev_fbf.c	(revision 657)
@@ -2,5 +2,5 @@
  * dev_fbf.c - FBF (Frame Buffer) generic device API implementation.
  * 
- * Author  Alain Greiner    (2016,2017,2018,2019)
+ * Author  Alain Greiner    (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -26,7 +26,12 @@
 #include <hal_gpt.h>
 #include <hal_drivers.h>
+#include <hal_irqmask.h>
+#include <hal_macros.h>
+#include <hal_uspace.h>
+#include <hal_vmm.h>
 #include <thread.h>
 #include <printk.h>
 #include <string.h>
+#include <memcpy.h>
 #include <chdev.h>
 #include <dev_fbf.h>
@@ -41,8 +46,12 @@
 char * dev_fbf_cmd_str( uint32_t cmd_type )
 {
-    if     ( cmd_type == FBF_READ       )  return "READ";
-    else if( cmd_type == FBF_WRITE      )  return "WRITE";
-    else if( cmd_type == FBF_GET_CONFIG )  return "GET_CONFIG";
-    else                                   return "undefined";
+    if     ( cmd_type == FBF_GET_CONFIG     )  return "GET_CONFIG";
+    else if( cmd_type == FBF_CREATE_WINDOW  )  return "CREATE_WINDOW";
+    else if( cmd_type == FBF_DELETE_WINDOW  )  return "DELETE_WINDOW";
+    else if( cmd_type == FBF_MOVE_WINDOW    )  return "MOVE_WINDOW";
+    else if( cmd_type == FBF_REFRESH_WINDOW )  return "REFRESH_WINDOW";
+    else if( cmd_type == FBF_DIRECT_WRITE   )  return "DIRECT_WRITE";
+    else if( cmd_type == FBF_DIRECT_READ    )  return "DIRECT_READ";
+    else                                       return "undefined";
 }
 
@@ -50,8 +59,27 @@
 void dev_fbf_init( chdev_t  * fbf )
 {
+    uint32_t wid;
+
     // set chdev name
     strcpy( fbf->name, "fbf" );
 
-    // call driver init function
+    // initialize lock protecting the windows
+    remote_rwlock_init( XPTR( local_cxy , &fbf->ext.fbf.windows_lock ),
+                        LOCK_FBF_WINDOWS ); 
+
+    // initialize root of windows xlist
+    xlist_root_init( XPTR( local_cxy , &fbf->ext.fbf.windows_root ) );
+
+    // initialize windows_tbl[] array
+    for( wid = 0 ; wid < CONFIG_FBF_WINDOWS_MAX_NR ; wid++ ) 
+    {
+        fbf->ext.fbf.windows_tbl[wid] = XPTR_NULL;
+    }
+
+    // initialize wid allocator bitmap
+    bitmap_init( fbf->ext.fbf.windows_bitmap , CONFIG_FBF_WINDOWS_MAX_NR );
+
+    // call driver init function to initialize the harware FBF
+    // and initialize the width, height, and subsampling FBF chdev fields
     hal_drivers_fbf_init( fbf );
 
@@ -66,5 +94,5 @@
     xptr_t  dev_xp = chdev_dir.fbf[0];
 
-    assert( (dev_xp != XPTR_NULL) , "undefined FBF chdev descriptor" );
+assert( (dev_xp != XPTR_NULL) , "undefined FBF chdev descriptor" );
 
     // get FBF chdev cluster and local pointer
@@ -79,19 +107,282 @@
 }  // end dev_fbf_get_config()
 
-/////////////////////////////////////////////////////
-error_t dev_fbf_move_data( uint32_t   cmd_type,
-                           void     * user_buffer,
-                           uint32_t   length,
-                           uint32_t   offset )
-{
-    // get pointer on calling thread
-    thread_t * this = CURRENT_THREAD;
+///////////////////////////////////////////////
+uint32_t dev_fbf_create_window( uint32_t   nlines,
+                                uint32_t   npixels,
+                                uint32_t   l_min,
+                                uint32_t   p_min,
+                                intptr_t * user_buffer )
+{
+    kmem_req_t     req;
+    fbf_window_t * window;      // window descriptor (created in local cluster)
+    vseg_t       * vseg;        // vseg descriptor (created in reference cluster)
+    intptr_t       vseg_base;   // vseg base address in user space  
+
+    // get local pointers on calling thread and process
+    thread_t  * this    = CURRENT_THREAD;
+    process_t * process = this->process;
 
 #if DEBUG_DEV_FBF
 uint32_t   cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_DEV_FBF < cycle )
-printk("\n[%s] thread[%x,%x] : %s / buffer %x / length %d / offset %x / cycle %d\n",
-__FUNCTION__ , this->process->pid, this->trdid,  
-dev_fbf_cmd_str(cmd_type), user_buffer, length, offset, cycle );
+printk("\n[%s] thread[%x,%x] enter : nlines %d / npixels %d / l_min %d / p_min %d / cycle %d\n",
+__FUNCTION__ , process->pid, this->trdid, nlines, npixels, l_min, p_min, cycle );
+#endif
+
+    // get cluster and pointers on FBF chdev
+    xptr_t      fbf_xp  = chdev_dir.fbf[0];
+    cxy_t       fbf_cxy = GET_CXY( fbf_xp );
+    chdev_t   * fbf_ptr = GET_PTR( fbf_xp );
+
+// check fbf_xp definition
+assert( (fbf_xp != XPTR_NULL) , "undefined FBF chdev descriptor" );
+
+    // get FBF width and height
+    uint32_t fbf_width  = hal_remote_l32( XPTR( fbf_cxy , &fbf_ptr->ext.fbf.width ) );
+    uint32_t fbf_height = hal_remote_l32( XPTR( fbf_cxy , &fbf_ptr->ext.fbf.height ) );
+
+    // check new window size and coordinates
+    if( (((l_min + nlines) > fbf_height) || ((p_min + npixels) > fbf_width)) )
+    {
+        printk("\n[ERROR] in %s / thread[%x,%x]" 
+        "illegal new coordinates (%d,%d) for window (%d,%d) in fbf (%d,%d)\n",
+        process->pid, this->trdid, p_min, l_min, npixels, nlines, fbf_width, fbf_height );
+        return -1;
+    }
+
+    // build extended pointers on windows lock, root, and wid allocator 
+    xptr_t windows_lock_xp   = XPTR( fbf_cxy , &fbf_ptr->ext.fbf.windows_lock );
+    xptr_t windows_root_xp   = XPTR( fbf_cxy , &fbf_ptr->ext.fbf.windows_root );
+    xptr_t windows_bitmap_xp = XPTR( fbf_cxy ,  fbf_ptr->ext.fbf.windows_bitmap );
+ 
+    // allocate memory for the window descriptor in local cluster
+    req.type   = KMEM_KCM;
+    req.order  = bits_log2( sizeof(fbf_window_t) );
+    req.flags  = AF_ZERO | AF_KERNEL;
+    window     = kmem_alloc( &req );
+
+    if( window == NULL )
+    {
+        printk("\n[ERROR] in %s / thread[%x,%x] cannot allocate window descriptor\n",
+        __FUNCTION__, process->pid, this->trdid );
+        return -1;
+    }
+
+#if (DEBUG_DEV_FBF & 1)
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_FBF < cycle )
+printk("\n[%s] thread[%x,%x] created window descriptor %x / cycle %d\n",
+__FUNCTION__ , process->pid, this->trdid, window, cycle );
+#endif
+
+    // getpointers on reference process
+    xptr_t      ref_xp  = process->ref_xp;
+    process_t * ref_ptr = GET_PTR( ref_xp );
+    cxy_t       ref_cxy = GET_CXY( ref_xp );
+
+    // allocate a new vseg, and introduce it in the reference process VSL
+    if( ref_cxy == local_cxy )
+    {
+        vseg = vmm_create_vseg( process,            // owner process
+                                VSEG_TYPE_ANON,     // localised, public
+                                0,                  // base, unused for ANON
+                                nlines * npixels,   // size
+                                0,                  // file_offset, unused for ANON 
+                                0,                  // file_size, unused for ANON
+                                XPTR_NULL,          // mapper_xp, unused for ANON
+                                local_cxy );        // mapping cluster
+    }
+    else
+    {
+        rpc_vmm_create_vseg_client( ref_cxy,
+                                    ref_ptr,
+                                    VSEG_TYPE_ANON,
+                                    0,                 // base, unused for ANON
+                                    nlines * npixels,  // size
+                                    0,                 // file_offset, unused for ANON
+                                    0,                 // file size, unused for ANON
+                                    XPTR_NULL,         // mapper_xp, unused for ANON
+                                    local_cxy,
+                                    &vseg );
+    } 
+        
+    if( vseg == NULL )
+    {
+        printk("\n[ERROR] in %s / thread[%x,%x] cannot create vseg in reference cluster\n",
+        __FUNCTION__, process->pid, this->trdid );
+        req.ptr = (void *)window;
+        kmem_free( &req );
+        return -1;
+    }
+
+    // get vseg base
+    vseg_base = (intptr_t)hal_remote_lpt( XPTR( ref_cxy , &vseg->min ) );
+
+#if (DEBUG_DEV_FBF & 1)
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_FBF < cycle )
+printk("\n[%s] thread[%x,%x] allocated vseg / base %x / cycle %d\n",
+__FUNCTION__ , process->pid, this->trdid, vseg_base, cycle );
+#endif
+
+    // take the lock protecting windows in write mode
+    remote_rwlock_wr_acquire( windows_lock_xp );
+
+    // allocate a wid from allocator in FBF descriptor extension
+    uint32_t wid = bitmap_remote_alloc( windows_bitmap_xp , CONFIG_FBF_WINDOWS_MAX_NR );
+
+    if( wid == 0xFFFFFFFF )
+    {
+        printk("\n[ERROR] in %s / thread[%x,%x] cannot allocate buffer for window\n",
+        __FUNCTION__, process->pid, this->trdid );
+        req.ptr = (void *)window;
+        kmem_free( &req );
+        vmm_remove_vseg( process , vseg );
+        return -1;
+    }
+ 
+    // initialize window descriptor
+    window->pid     = process->pid;
+    window->wid     = wid;
+    window->height  = nlines;
+    window->width   = npixels;
+    window->l_min   = l_min;
+    window->p_min   = p_min;
+    window->hidden  = false;
+    window->buffer  = (uint8_t *)vseg_base;
+
+    // register new window in xlist rooted in FBF extension
+    xlist_add_last( windows_root_xp , XPTR( local_cxy , &window->xlist ) );
+
+    // build extended pointer on relevant entry in windows_tbl[] array
+    xptr_t windows_tbl_xp = XPTR( fbf_cxy , &fbf_ptr->ext.fbf.windows_tbl[wid] );
+
+    // register new window in windows_tbl[] stored in FBF extension
+    hal_remote_s64( windows_tbl_xp , XPTR( local_cxy , window ) );
+
+    // release the lock protecting windows in write mode
+    remote_rwlock_wr_release( windows_lock_xp );
+
+#if DEBUG_DEV_FBF
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_FBF < cycle )
+printk("\n[%s] thread[%x,%x] exit / wid %d / buffer %x / cycle %d\n",
+__FUNCTION__ , this->process->pid, this->trdid, wid , window->buffer, cycle );
+#endif
+
+#if (DEBUG_DEV_FBF & 1)
+hal_vmm_display( ref_xp , true );
+#endif
+
+    // return pointer on allocated buffer
+    *user_buffer = vseg_base;
+
+    return wid;
+
+}  // end dev_fbf_create_window()
+
+////////////////////////////////////////////////////////////////////////////////////////
+// This static function is called by the dev_fbf_display() function.
+// For a partial FBF line, identified by the <f_line>, <f_p_min>, <f_p_max> arguments
+// in FBF reference, and for one remote window, identified by the <window_xp> argument,
+// it updates the target buffer identified by <t_buffer>, and containing exactly
+// (f_p_max - f_p_min) pixels. 
+// Depending on the actual overlap between the window and the <t_buffer> representing 
+// the partial FBF line, it moves up to (f_p_max - f_p_min) pixels from the window 
+// buffer to the target buffer. The number of moved pixels can be nul if no overlap.
+////////////////////////////////////////////////////////////////////////////////////////
+// @ f_line     : [in]  line index in FBF reference (from 0 to fbf_height-1).
+// @ f_p_min    : [in]  first pixel in FBF line.
+// @ f_p_max    : [in]  last pixel in FBF line (excluded). 
+// @ window_xp  : [in]  extended pointer on checked window .
+// @ t_buffer   : [out] local pointer on target buffer to be updated.
+///////////////////////////////////////////////////////////////////////////////////////
+__attribute__ ((noinline)) static void handle_one_window( uint32_t  f_line,
+                                                          uint32_t  f_p_min,
+                                                          uint32_t  f_p_max,
+                                                          xptr_t    window_xp,
+                                                          uint8_t * t_buffer )
+{
+    // get remote window descriptor cluster and local pointer
+    cxy_t          window_cxy = GET_CXY( window_xp );
+    fbf_window_t * window_ptr = GET_PTR( window_xp );
+
+    // get remote window min/max coordinates in FBF reference
+    uint32_t  w_l_min    = hal_remote_l32( XPTR( window_cxy , &window_ptr->l_min ) );
+    uint32_t  w_p_min    = hal_remote_l32( XPTR( window_cxy , &window_ptr->p_min ) );
+    uint32_t  w_height   = hal_remote_l32( XPTR( window_cxy , &window_ptr->height ) );
+    uint32_t  w_width    = hal_remote_l32( XPTR( window_cxy , &window_ptr->width  ) );
+    uint32_t  w_l_max    = w_l_min + w_height;
+    uint32_t  w_p_max    = w_p_min + w_width;
+
+    // does nothing if partial FBF line does not overlap the window
+    if( (f_line < w_l_min)  || (f_line >= w_l_max) ||
+        (f_p_max < w_p_min) || (f_p_min >= w_p_max) ) return;
+
+    // get pointer on window buffer in user space
+    uint8_t * w_buffer = hal_remote_lpt( XPTR( window_cxy , &window_ptr->buffer ) ); 
+
+    // get min & max indexes for pixels to be moved in FBF reference
+    uint32_t f_pixel_min = (f_p_min < w_p_min) ? w_p_min : f_p_min;
+    uint32_t f_pixel_max = (f_p_max < w_p_max) ? f_p_max : w_p_max;
+
+    // compute number of pixels to move from w_buffer to f_buffer
+    uint32_t npixels = f_pixel_max - f_pixel_min;
+
+    // compute offset in target buffer
+    uint32_t t_offset = f_pixel_min - f_p_min; 
+
+    // compute line index in window  
+    uint32_t w_line = f_line - w_l_min;
+
+    // compute offset in window buffer
+    uint32_t w_offset = (w_line * w_height) + f_pixel_min - w_p_min;
+
+    // move pixels from w_buffer (user space) to t_buffer in kernel space
+    hal_copy_from_uspace( XPTR( local_cxy  , &t_buffer[t_offset]  ),
+                          &w_buffer[w_offset], 
+                          npixels );
+
+}  // end handle_one_window()
+
+////////////////////////////////////////////////////////////////////////////////////////
+// This static function is called by dev_fbf_refresh_window(), dev_fbf_move_window(),
+// dev_fbf_resize_window(), and dev_fbf_delete_window(). It updates all lines of the
+// window identified by the <window_xp>, <line_first>, and <line_last>> arguments. 
+// It scan all registered windows to take into account the overlap priorities defined 
+// by the windows xlist. It does not take the lock protecting the xlist, that must be 
+// taken by the calling function.
+////////////////////////////////////////////////////////////////////////////////////////
+// @ window_xp  : [in]  extended pointer on window defining the FBF pixels to refresh.
+// @ line_first : [in]  first line index.
+// @ line_last  : [in]  last line index (excluded).
+////////////////////////////////////////////////////////////////////////////////////////
+error_t fbf_update( xptr_t    window_xp,
+                    uint32_t  line_first,
+                    uint32_t  line_last )
+{
+    uint32_t       line;                // iterator to scan the FBF lines
+    uint32_t       pixel;               // iterator to scan pixels in one FBF line
+    xptr_t         iter_xp;             // iterator to scan the list of windows
+    error_t        error;
+
+    // this intermediate buffer stores one line in
+    // target window, to handle other windows overlap
+    uint8_t       line_buffer[CONFIG_FBF_WINDOWS_MAX_WIDTH];
+
+    // get pointer on calling thread and core lid
+    thread_t  * this = CURRENT_THREAD;
+
+    // get window cluster and local pointer
+    cxy_t          window_cxy = GET_CXY( window_xp );
+    fbf_window_t * window_ptr = GET_PTR( window_xp );
+
+#if DEBUG_DEV_FBF
+uint32_t wid   = hal_remote_l32( XPTR( window_cxy , &window_ptr->wid ) );
+uint32_t lid   = this->core->lid;
+uint32_t cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_DEV_FBF < cycle )
+printk("\n[%s] core[%x,%d] enter / wid %d / cycle %d\n",
+__FUNCTION__, local_cxy, lid, wid, cycle );
 #endif
 
